package java.time.temporal;

import java.time.format.ResolverStyle;
import java.util.Map;
import java.util.Objects;
import java.util.Locale;

public interface TemporalField
{
    default public String getDisplayName(Locale obj) {
        Objects.requireNonNull(obj, "locale");
        return this.toString();
    }
    
    public abstract TemporalUnit getBaseUnit();
    
    public abstract TemporalUnit getRangeUnit();
    
    public abstract ValueRange range();
    
    public abstract boolean isDateBased();
    
    public abstract boolean isTimeBased();
    
    public abstract boolean isSupportedBy(TemporalAccessor p0);
    
    public abstract ValueRange rangeRefinedBy(TemporalAccessor p0);
    
    public abstract long getFrom(TemporalAccessor p0);
    
    public abstract <R extends Temporal> R adjustInto(R p0, long p1);
    
    default public TemporalAccessor resolve(Map<TemporalField, Long> map, TemporalAccessor temporalAccessor, ResolverStyle resolverStyle) {
        return null;
    }
    
    public abstract String toString();
}
